package org.ajax4jsf.portlet;

import javax.faces.context.FacesContext;
import javax.portlet.faces.BridgeException;

import org.ajax4jsf.portlet.application.PortletViewState;

/**
 * @author asmirnov
 *
 */
public interface ExceptionHandler {
	
	/**
	 * Process JSF exceptions at the portlet action phase
	 * @param context
	 * @param windowState
	 * @param e
	 * @throws BridgeException
	 */
	public void processActionException(FacesContext context, PortletViewState windowState, Exception e) throws BridgeException;

	/**
	 * Process JSF exceptions at the portlet render phase.
	 * @param context
	 * @param windowState
	 * @param e
	 * @throws BridgeException
	 */
	public void processRenderException(FacesContext context, PortletViewState windowState, Exception e) throws BridgeException;

}
